import com.digitalsanctum.webdsl.component.Page;
import com.digitalsanctum.webdsl.util.ComponentWriter;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 *
 * @author shane
 * @since Jul 30, 2010 10:36:40 AM
 */
public class Website {

    private String title;
    private static Map<String, Page> pages = new HashMap<String, Page>();
    private ComponentWriter writer;

    public Website(String title) {
        this.title = title;
    }

    public ComponentWriter getWriter() {
        return writer;
    }

    public Website setWriter(ComponentWriter writer) {
        this.writer = writer;
        return this;
    }

    public String getTitle() {
        return title;
    }

    public static Map<String, Page> getPages() {
        return pages;
    }

    public Website addPage(Page p) {
        pages.put(p.getId(), p);
        return this;
    }

    public Website generate(String dirPath) {

        File f = new File(dirPath);
        if (!f.exists()) f.mkdir();

        for (Page p : getPages().values()) {
            String filePath = new File(f, p.getFilename()).getAbsolutePath();
            writer.write(p, filePath);
        }

        return this;
    }
}
